
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol::Endpoint
  module Entities

    def producer(options = {})
      entity :Producer, options
    end

    def consumer(options = {})
      entity :Consumer, options
    end

    def dialog_server(options = {})
      entity 'Dialog::Server', options
    end

    def dialog_client(options = {})
      entity 'Dialog::Client', options
    end

    def rpc_server(options = {})
      entity 'RPC::Server', options
    end

    def rpc_client(options = {})
      entity 'RPC::Client', options
    end


    def entity(klass, options)

      k =
        sync? ? "Tomte::Protocol::Sync::#{klass.to_s}" :
                "Tomte::Protocol::#{klass.to_s}"

      entity = k.constantize.new(self.async, options)
      entity.enveloper ||= enveloper
      entity
    end
  end
end