
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol

  module Enveloper


    module Consumer
      extend ActiveSupport::Concern

      included do
        include Hooks
        attr_accessor :enveloper
      end

      def initialize(channel, queue, consumer_tag = nil, exclusive = false, no_ack = false, arguments = {}, no_local = false)
        super
        @enveloper = @channel.enveloper
      end

      def on_delivery(&block)
        delivery_shim = Proc.new { | headers, payload, consumer_tag, delivery_tag, redelivered, exchange, routing_key |

          data = envelope_wire_to_local(payload, headers,
                                        :consumer_tag => consumer_tag,
                                        :delivery_tag => delivery_tag,
                                        :redelivered => redelivered,
                                        :exchange => exchange,
                                        :routing_key => routing_key)

          case block.arity
          when 1 then
            block.call(data.payload)
          when 2 then
            block.call(data.metadata, data.payload)
          else
            block.call(data.metadata, data.payload, consumer_tag,
                       delivery_tag, redelivered, exchange, routing_key)
          end
        }

        super(&delivery_shim)
      end

    end
  end
end
