
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol

  module Enveloper

    module Exchange
      extend ActiveSupport::Concern

      included do
        include Hooks
      end

      def initialize(channel, type, name, opts = {}, &block)
        super

        @enveloper = (opts && opts.delete(:enveloper)) || @channel.enveloper
      end


      def publish(payload, options = {}, &block)
        data = envelope_local_to_wire(payload, options)
        super(data.body, data.metadata)
      end

    end

  end
end