
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol
  module Enveloper
    module Hooks

      attr_accessor :enveloper

      private
      #######
      #
      # does serialization of a message
      #
      def envelope_local_to_wire(message, options = {})
        if @enveloper.nil?
          WireResponse.new(message, options)
        else
          @enveloper.local_to_wire(message, options)
        end
      end

      #
      # does the unserialization
      #
      def envelope_wire_to_local(body, headers, options ={})
        if @enveloper.nil?
          LocalResponse.new(body, headers)
        else
          @enveloper.wire_to_local(body, headers, options)
        end
      end
    end
  end
end