# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol

  class Exchange < AMQP::Exchange

    #include Enveloper::Exchange

    attr_reader :channel

    def self.default(channel)
      self.new(channel, :direct, AMQ::Protocol::EMPTY_STRING, :no_declare => true)
    end

    def initialize(channel, type, name, opts = {}, &block)
      super
      # sort of a monkeypatch, for a bug in the AMQP library
      # nowait is handled as a persistent property of the exchange
      # while should be local to the method, so, don't keep it
      #
      @opts.delete(:nowait)
    end

  end

end