
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2012, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Protocol::Sync::Dialog
  class Client
    include Tomte::Protocol::Synchronization
    include Tomte::Protocol::Sync::Entity

    attr_reader :entity

    def initialize(connection, options = {})

      initialize_from_async_entity connection
      @entity ||= Tomte::Protocol::Dialog::Client.new(connection, options)
    end

    def call(object, options = {})
      resync do |wc|
        errback = proc { |exception| wc.return_raise exception }

        @entity.call(object, {:errback => errback}.merge(options)) do |response|
          wc.return_raise(response.payload) if response.payload.is_a?(Exception)
          wc.return(
            options[:metadata] ?
              response :
              response.payload)
        end
      end
    end

  end
end